# -*- coding: utf-8 -*-
'''
Praktium 13, lahendused.
Viimati uuendatud 25.11.2024
'''

#%% ül 1

class Point:
    
    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def __add__(self, other):
        return Point(self.x + other.x, self.y + other.y)
    
    def __repr__(self):  # Meetodile vatab repr funtsioon.
        return f'{(self.x, self.y)}'


p1 = Point(1, 2)
p2 = Point(2, 3)

result = p1 + p2

print(p1)
print(p2)
print(result)  # --> (3, 5)


#%% ül 1, teine lahend.

class Point:
    
    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def __add__(self, other):
        return Point(self.x + other.x, self.y + other.y)
        #return type(self)(self.x + other.x, self.y + other.y)  # Nii saab ka.

    def __str__(self):  # Esitus sõnena konsoolis ja mujal.
        return f'{(self.x, self.y)}'
    
    def __repr__(self):  # Meetodile vatab repr funtsioon.
        return f'{(self.x, self.y)}'


p1 = Point(1, 2)
p2 = Point(2, 3)

result = p1 + p2

print(p1)
print(p2)
print(result)  # --> (3, 5)


#%% ül 2

class Punkt:
    
    def __init__(self, x, y):
        self.x = x
        self.y = y
    
    def kaugus_punktist(self, other):
        dx = self.x - other.x
        dy = self.y - other.y
        return (dx**2 + dy**2)**0.5
    
    def liiga_ligidal(self, other, ligidus):
        if self.kaugus_punktist(other) >= ligidus:
            print('Liiga ligidal!')
        else:
            print('Korras, kaugel')


punkt1 = Punkt(3, 4)
punkt2 = Punkt(0, 0)

print(punkt1.kaugus_punktist(punkt2))
punkt1.liiga_ligidal(punkt2, 4)


#%% ül 3

class Olend:
    
    def __init__(self, jalgu, tiibu):
        self.jalgu = jalgu  # Täisarv.
        self.tiibu = tiibu  # Täisarv.
    
    @property
    def milline(self):
        if self.jalgu == 2: 
            if self.tiibu == 1:
                print('Kahejalgne olend kellel on üks tiib.')
            elif self.tiibu == 0:
                print('Kahejalgne olend kellel pole tiibu.')
            else:    
                print(f'Kahejalgne olend kellel on {self.tiibu} tiiba.')
        elif self.jalgu == 4:
            if self.tiibu == 1:
                print('Neljajalgne olend kellel on üks tiib.')
            elif self.tiibu == 0:
                print('Neljajalgne olend kellel pole tiibu.')
            else:
                print(f'Neljajalgne olend kellel on {self.tiibu} tiiba')
        else:
            if self.tiibu == 1:
                print('Mitte kahe- või neljajalgne olend kellele on üks tiib.')
            elif self.tiibu == 0:
                print('Mitte kahe- või neljajalgne olend kellel pole tiibu.')
            else:
                print(f'Mitte kahe- või neljajalgne olend kellele on {self.tiibu} tiiba.')
                

olend = Olend(2, 0)
olend.milline


#%% ül 4

class Imetaja:
    
    def __init__(self, nimi):
        print(nimi, "on imetaja.")
         

class OskabLennata(Imetaja):
    
    def __init__(self, oskabLennata_nimi):
        print(oskabLennata_nimi, "ei oska lennata.")
        super().__init__(oskabLennata_nimi)
        
                    
class OskabUjuda(Imetaja):
    
    def __init__(self, oskabUjuda_nimi):
        print(oskabUjuda_nimi, "ei oska ujuda.")
        super().__init__(oskabUjuda_nimi)
        
             
class Loom(OskabLennata, OskabUjuda):
    
    def __init__(self, nimi):
        super().__init__(nimi)
        
        
Tom = Loom("Koer")

# Miks selline järjekord? Kuna MRO on selline.
print()
help(Loom)
print(Loom.mro())
print(Loom.__mro__)


#%% ül 5, Kasutades funktsiooni super.

class Loomad:
    
    def __init__(self):
        self.jalad = 4
        self.kodustatud = True
        self.saba = True
        self.imetaja = True
        
    def on_imetaja(self):
        if self.imetaja:
            print("On imetaja.")
     
    def on_kodustatud(self):
        if self.kodustatud:
            print("On kodustatud loom.")
            

class Koerad(Loomad):
    
    def __init__(self):
        super().__init__()

        
class Hobused(Loomad):
    
    def __init__(self):
        super().__init__()
 
    def omab_saba(self):
        if self.saba and self.jalad == 4:
            print("On saba ja jalad.")
        else:
            print("4 saba ja 4 jalgs pole.")


Tom = Koerad()
Bruno = Hobused()

Tom.on_imetaja()
Tom.on_kodustatud()
print()
Bruno.on_imetaja()
Bruno.on_kodustatud()
Bruno.omab_saba()


#%% ül 5, Kasutades superklassi nime, eeldan et klass loomad on masina mälus.

class Loomad:
    
    def __init__(self):
        self.jalad = 4
        self.kodustatud = True
        self.saba = True
        self.imetaja = True
        
    def on_imetaja(self):
        if self.imetaja:
            print("On imetaja.")
     
    def on_kodustatud(self):
        if self.kodustatud:
            print("On kodustatud loom.")
            
            
class Koerad(Loomad):
    
    def __init__(self):
        Loomad.__init__(self)

        
class Hobused(Loomad):
    
    def __init__(self):
        Loomad.__init__(self)
 
    def omab_saba(self):
        if self.saba and self.jalad == 4:
            print("On saba ja jalad.")
        else:
            print("4 saba ja 4 jalgs pole.")


Tom = Koerad()
Bruno = Hobused()

Tom.on_imetaja()
Tom.on_kodustatud()
print()
Bruno.on_imetaja()
Bruno.on_kodustatud()
Bruno.omab_saba()


#%% ül 5, teine lahend.
# Kasutades funktsiooni super.

class Loomad:
    
    def __init__(self):
        self.jalad = 4
        self.kodustatud = True
        self.saba = True
        self.imetaja = True
        
    def on_imetaja(self):
        if self.imetaja:
            return "On imetaja."
     
    def on_kodustatud(self):
        if self.kodustatud:
            return "On kodustatud loom."
            

class Koerad(Loomad):
    
    def __init__(self):
        super().__init__()

        
class Hobused(Loomad):
    
    def __init__(self):
        super().__init__()
 
    def omab_saba(self):
        if self.saba and self.jalad == 4:
            return "On saba ja jalad."
        else:
            return "4 saba ja 4 jalgs pole."


Tom = Koerad()
Bruno = Hobused()

print(Tom.on_imetaja())
print(Tom.on_kodustatud())
print()
print(Bruno.on_imetaja())
print(Bruno.on_kodustatud())
print(Bruno.omab_saba())


#%% ül 6
import math

class Loomad:
    
    def __init__(self):
        self.jalad = 4
        self.kodustatud = True
        self.saba = True
        self.imetaja = True
        
    def on_imetaja(self):
        if self.imetaja:
            print("On imetaja.")
     
    def on_kodustatud(self):
        if self.kodustatud:
            print("On kodustatud loom.")
    
    @staticmethod        
    def lnsum(*arvud):
        return math.log(sum(arvud))
    

kass = Loomad()

print(kass.lnsum(1, 0, 0, 0, 0))  # Läbi objekti.
print(Loomad.lnsum(1, 0, 0, 0, 0))  # Läbi klassi.


#%% ül 7

class Tudeng:
    
    kursus = 'Python YFX0500'
    hinne = None
 
    @classmethod
    def prindi(cls):
        print("Tudeng õpib kursusel:", cls.kursus)
        
    @classmethod
    def lisahinne(cls, hinne):
        cls.hinne = hinne
        print("Kursuse hinne on", cls.hinne)


# Kontroll, kasutades klassi.
Tudeng.prindi()
print(Tudeng.hinne)
Tudeng.lisahinne(5)
print(Tudeng.hinne)

# Kontroll, kasutades objekti.
print()
Juhan = Tudeng()
Juhan.prindi()
print(Juhan.hinne)
Juhan.lisahinne(6)
print(Juhan.hinne)


#%% ül 8

class A:
    __cls_A_a = 1
    __cls_A_b = 22

    def __init__(self, obj_a, obj_b):
        self.__obj_a = obj_a
        self.__obj_b = obj_b

    def __cls_A_method(self):
        return 'obj_a = {} and obj_b = {}.'.format(self.__obj_a, self.__obj_b)

    def data(self):  # Avalik meetod.
        obj_b_id = id(self.__obj_b)
        return 'obj_b = {}, obj_b id = {}.'.format(self.__obj_b, obj_b_id)


obj = A(3, 44)

print(obj.data())


#%% ül 9

class Tudeng:

    def __init__(self, nimi, perenimi, sugu, kaal, oppekava=None, hiv=False):
        self.__nimi = nimi
        self.__perenimi = perenimi
        self.__sugu = sugu
        self.__kaal = kaal
        self.__oppekava = oppekava
        self.__hiv = hiv

    def __repr__(self):
        if self.__hiv:
            return f"NB! Tudeng {self.__nimi} {self.__perenimi} on HIV parasiit, ära suru tema kätt! Löö teda!"
        else:
            return f"Tudeng {self.__nimi} {self.__perenimi} kes kaalub {self.__kaal} kg on jumala ingel."


tudeng1 = Tudeng('Juulius', 'Tipikas', 'mees', 150, 'füüsika', True)

print(tudeng1)


#%% ül 10

class Tudeng:

    def __init__(self, nimi, perenimi, sugu, kaal, oppekava=None, hiv=False):
        self.__nimi = nimi
        self.__perenimi = perenimi
        self.__sugu = sugu
        self.__kaal = kaal
        self.__oppekava = oppekava
        self.__hiv = hiv

    def hiv_staatus(self):
        if self.__hiv:
            return f"NB! Tudeng {self.__nimi} {self.__perenimi} on HIV parasiit, ära suru tema kätt! Löö teda!"
        else:
            return f"Tudeng {self.__nimi} {self.__perenimi} kes kaalub {self.__kaal} kg on jumala ingel."

    def __repr__(self):
        return f"Tudeng {self.__nimi} {self.__perenimi} kes õpib {self.__oppekava} õppekaval."


tudeng1 = Tudeng('Juulius', 'Tipikas', 'mees', 150, 'füüsika', True)

print(tudeng1)
print(tudeng1.hiv_staatus())


#%% ül 11

class Tudeng:

    def __init__(self, nimi, perenimi, sugu, kaal, oppekava=None, hiv=False):
        self.__nimi = nimi
        self.__perenimi = perenimi
        self.__sugu = sugu
        self.__kaal = kaal
        self.__oppekava = oppekava
        self.__hiv = hiv

    def __hiv_staatus(self):
        if self.__hiv:
            return f"NB! Tudeng {self.__nimi} {self.__perenimi} on HIV parasiit, ära suru tema kätt! Löö teda!"
        else:
            return f"Tudeng {self.__nimi} {self.__perenimi} kes kaalub {self.__kaal} kg on jumala ingel."

    def saladus(self):
        return self.__hiv_staatus()

    def __repr__(self):
        return f"Tudeng {self.__nimi} {self.__perenimi} kes õpib {self.__oppekava} õppekaval."


tudeng1 = Tudeng('Juulius', 'Tipikas', 'mees', 150, 'füüsika', True)

print(tudeng1)
print(tudeng1.saladus())


#%% ül 12

class Juurjalg:
    isendid = []
    punaste_arv = 0
    roheliste_arv = 0

    def __init__(self, kaal, kas_punane=True, junni_protsent=20):
        self.kaal = kaal
        self.algne_kaal = kaal
        self.kas_punane = kas_punane
        self.junni_protsent = junni_protsent
        Juurjalg.isendid.append(self)
        if kas_punane:
            Juurjalg.punaste_arv += 1
        else:
            Juurjalg.roheliste_arv += 1

    def __repr__(self):
        if self.kas_punane:
            varv = 'Punane'
        else:
            varv = 'Roheline'
        return f'{varv} loom kaaluga {self.kaal} kelle junn on {self.junni_protsent}% tema kehakaalust.'

    def __situ(self):
        self.kaal -= (self.junni_protsent / 100) * self.kaal

    def __paljune(self):
        if self.kaal >= 3 * self.algne_kaal:
            junni_protsent = 1.1 * self.junni_protsent  # Situb rohkem seega kasvab sama toidu kogusega aeglasemalt.
            if Juurjalg.punaste_arv > Juurjalg.roheliste_arv:
                kas_punane = False
                Juurjalg(self.algne_kaal, kas_punane, junni_protsent)
            else:
                kas_punane = True 
                Juurjalg(self.algne_kaal, kas_punane, junni_protsent)
            self.kaal -= self.algne_kaal  # Sünniga seotud kaalulangus.
            return True
        else:
            return False
            
    def toitu(self, toidu_kaal):
        if toidu_kaal > 0:
            self.kaal += toidu_kaal
            self.__situ()  # Toitumisel järgneb alati situmine.
        else:
            raise ValueError('Toit peab midagi kaaluma.')
        paljunes = self.__paljune()  # Võimalusel paljuneb.
        if paljunes:
            isend_arv = Juurjalg.punaste_arv + Juurjalg.roheliste_arv  # Või len(Juurjalg.isendid).
            punased = Juurjalg.punaste_arv
            rohelised = Juurjalg.roheliste_arv
            return f'''Nam namm nom nomm...
Loom oli nii paks et paljunes!
Populatsiooni suurus: {isend_arv} isendit (punaseid {punased}, rohelisi {rohelised}).
Looma kaal peale toitumist, sittumist ja paljunemist on {self.kaal}.\n'''
        else:
            return f'Nam namm nom nomm...\nLooma kaal peale toitumist ja sittumist on {self.kaal}.\n'
        
        
loom1 = Juurjalg(2)  # Vaikimisi punane ja junni protsent on 20%.

# Toidan looma 10 korda:
for _ in range(10):
    print(loom1.toitu(2.5))

# Looma andmed peale korduvat toitumist.
print('\tLooma andmed peale korduvat toitumist.')
print(loom1)

# Eksisteerivad isendid:
print('\n\tEksisteerivad isendid:')
for i in Juurjalg.isendid:
    print(i)


#%% ül 13

class Bank:
    
    def __init__(self, name, balance):
        """Creates new bank card."""
        self.name = name
        self.balance = balance

    def get_balance(self):
        return self.balance

    def deposit(self, amount):
        """
        Deposit money to bank account.
        Deposit can be made if amount is not negative.
        """
        if amount < 0:
            return False
        self.balance += amount
        return True

    def withdraw(self, amount):
        """
        Withdraw money from bank account.
        Withdraw can't be made if amount is negative or
        withdrawal would end with negative balance.
        """
        if amount < 0 or self.balance - amount < 0:
            return False
        self.balance -= amount
        return True


konto = Bank('Juulius', 500)

print(konto.get_balance())
print(konto.deposit(300))
print(konto.get_balance())
print(konto.withdraw(300))
print(konto.get_balance())
print(konto.withdraw(1500))  # Ei õnnestu.
print(konto.get_balance())


#%% ül 14

class Bank:
    
    def __init__(self, name, balance):
        self.name = name
        self.balance = balance

    def get_balance(self):
        return self.balance

    def deposit(self, amount):
        if amount < 0:
            return False
        self.balance += amount
        return True

    def withdraw(self, amount):
        if amount < 0 or self.balance - amount < 0:
            return False
        self.balance -= amount
        return True
    
    def transfer(self, to_account, amount):
        if self.name == to_account.name:
            return False
        return self.withdraw(amount) and to_account.deposit(amount)


konto1 = Bank('Juulius', 1000)
konto2 = Bank('Juuli', 2000)

print(konto1.transfer(konto2, 500))
print(konto1.get_balance())
print(konto2.get_balance())


#%% ül 15, NB! Klass Bank peab olema mälus!!!!!

class CreditCard(Bank):
    
    def __init__(self, name, balance, credit_limit = 1000):
        super().__init__(name, balance)  # võtab ülalt
        self.credit_limit = credit_limit

    def withdraw(self, amount):
        if amount < 0:
            return False
        if self.balance + self.credit_limit - amount < 0:
            return False
        self.balance -= amount
        return True

        
kkonto1 = CreditCard('Juuli', 2000, 3000)

print(kkonto1.get_balance())
print(kkonto1.withdraw(5000))

print(kkonto1.get_balance())


#%% ül 15, teine lahend. NB! Klass Bank peab olema mälus!!!!!

#Tõstatame erisuse
class CreditCard(Bank):
    
    def __init__(self, name, balance, credit_limit = 1000):
        super().__init__(name, balance)  # võtab ülalt
        self.credit_limit = credit_limit

    def withdraw(self, amount):
        if amount < 0:
            raise Exception("Can't withdraw negative amount")
        if self.balance + self.credit_limit - amount < 0:
            raise Exception("Withdrawal can't exceed credit limit")
        self.balance -= amount

        
kkonto1 = CreditCard('Juuli', 2000, 3000)

print(kkonto1.get_balance())
kkonto1.withdraw(5000)
print(kkonto1.get_balance())


#%% ül 15, kolmas lahend.

# Käsitsi loodud erisuse kasutus
class IllegalAction(Exception):  # Pärin baaserisusest kõik
    pass                         # ja ei lisa midagi.


class DebitCard:  # Uus nimi.
    
    def __init__(self, name, balance):
        self.name = name
        self.balance = balance

    def get_balance(self):
        return self.balance

    def deposit(self, amount):
        if amount < 0:
            raise IllegalAction("Can't deposit negative amount")
        self.balance += amount

    def withdraw(self, amount):
        if amount < 0:
            raise IllegalAction("Can't withdraw negative amount")
        if self.balance - amount < 0:
            raise IllegalAction("Can't withdraw more money than account has")
        self.balance -= amount


class CreditCard(DebitCard):
    
    def __init__(self, name, balance, credit_limit = 1000):
        super().__init__(name, balance)  # Võtab ülalt.
        self.credit_limit = credit_limit

    def withdraw(self, amount):
        if amount < 0:
            raise IllegalAction("Can't withdraw negative amount")
        if self.balance + self.credit_limit - amount < 0:
            raise IllegalAction("Withdrawal can't exceed credit limit")
        self.balance -= amount

        
kkonto1 = CreditCard('Juuli', 2000, 3000)

print(kkonto1.get_balance())
kkonto1.withdraw(5000)
print(kkonto1.get_balance())


#%% ül 16  

class ObjectWithWeight:
    
    def __init__(self, weight):
        self.weight = weight

        
class ObjectWithNameAndWeight(ObjectWithWeight):
    
    def __init__(self, name, weight):
        ObjectWithWeight.__init__(self, weight)
        self.name = name
        
    def __repr__(self):
        return '{}({}, {})'.format(type(self).__name__, self.name, self.weight)


class Fruit(ObjectWithNameAndWeight):
    
    def take_a_bite(self, weight):
        actual_weight = min(self.weight, weight)
        self.weight -= actual_weight
        return weight - actual_weight


class Basket(list, ObjectWithWeight):
    
    @property
    def weight(self):
        return sum(o.weight for o in self)

    def take_a_bite(self, weight):
        shortage = weight
        for o in self:
            shortage = o.take_a_bite(shortage)
        return shortage


class Animal(ObjectWithNameAndWeight):
    
    def feed(self, food, meal_weight):
        shortage = food.take_a_bite(meal_weight)
        self.weight += meal_weight - shortage
        if shortage > 0:
            return 'still hungry'
        return 'fed up'


a = Fruit('Apple', 200)
b = Fruit('Banana', 100)
fruits = Basket([a, b])
dog = Animal('Muki', 5000)

print(dog, fruits)
#-> Animal(Muki, 5000) [Fruit(Apple, 200), Fruit(Banana, 100)]

print(dog.feed(fruits, 150))
#-> fed up

print(dog, fruits)
#-> Animal(Muki, 5150) [Fruit(Apple, 50), Fruit(Banana, 100)]



























